POJ 3463 最(次)短路条数

Sightseeing

Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 9497   Accepted: 3340

Description

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

Input

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

  • One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.
  • M lines, each with three integers AB and L, separated by single spaces, with 1 ≤ AB ≤ NA ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.

    The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.

  • One line with two integers S and F, separated by a single space, with 1 ≤ SF ≤ N and S ≠ F: the starting city and the final city of the route.

    There will be at least one route from S to F.

Output

For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.

Sample Input

2
5 8
1 2 3
1 3 2
1 4 5
2 3 1
2 5 3
3 4 2
3 5 4
4 5 3
1 5
5 6
2 3 1
3 2 1
3 1 10
4 5 2
5 2 7
5 2 7
4 1

Sample Output

3
2

Hint

The first test case above corresponds to the picture in the problem description.

题意:旅行团每天固定的从S地出发到达T地,为了省油要求尽量走最短路径或比最短路径长1单位距离的路径,求满足条件的路径条数

算法:最短路和次短路。Dijkstra算法。采用邻接表建图。

dis[x][2]:dis[x][0]表示起点到x的最短路、dis[x][1]表示起点到x的次短路;

arr[x][2]:arr[x][0]表示起点到x的最短路条数、arr[x][1]表示起点到x的次短路的条数;

vis[x][2]对应于x和0、1功能为记录该点是否被访问!

那么如何更新最小和次小路呢?显然我们容易想到下面的方法:

1.if(x<最小)更新最小,次小;
      2.else if(x==最小)更新方法数;
      3.else if(x<次小)更新次小;
      4.else if(x==次小)更新方法数;

最后说说dijkstra的循环部分、这也是本题的关键。为什么我们要循环2*nnum-1次?显然这道题中我们每一条边都需要考虑、这不是在求最短的一条,说白了是让你求出所有的可能组合,那么我们势必对每一种情况都需要遍历一次,虽然中间有重复。最短路里已知[start][0]已被标记为访问过,那么就只有nnum-1次遍历了,而次短路我们则需要遍历nnum次,这样两者加起来就为2*nnum-1次。这与我们平时使用优先队列+heap是一样的。只是更加细化了而已。

代码:

  1 //#include<bits/stdc++.h>
  2 //#include<regex>
  3 #include <vector>
  4 #include <cstdio>
  5 #include "cstring"
  6 #include <algorithm>
  7 #define db double
  8 #define ll long long
  9 #define vec vector<ll>
 10 #define Mt  vector<vec>
 11 #define ci(x) scanf("%d",&x)
 12 #define cd(x) scanf("%lf",&x)
 13 #define cl(x) scanf("%lld",&x)
 14 #define pi(x) printf("%d\n",x)
 15 #define pd(x) printf("%f\n",x)
 16 #define pl(x) printf("%lld\n",x)
 17 #define MP make_pair
 18 #define PB push_back
 19 #define fr(i,a,b) for(int i=a;i<=b;i++)
 20 using namespace std;
 21 const int N=1e6+5;
 22 const int mod=1e9+7;
 23 const int MOD=mod-1;
 24 const db  eps=1e-18;
 25 //const db  pi = acos(-1.0);
 26 const int inf = 0x3f3f3f3f;
 27 const ll  INF = 0x3f3f3f3f3f3f3f3f;
 28 int h[N],d[N][2],c[N][2];
 29 bool vis[N][2];
 30 struct P
 31 {
 32     int v,w,nx;
 33     P(int x,int y,int z):v(x),w(y),nx(z){};
 34     P(){};
 35 };
 36 vector<P> e;
 37 int cnt,n,m,t;
 38 void add(int x,int y,int z)
 39 {
 40
 41     e.push_back(P(y,z,h[x]));
 42     h[x]=cnt++;
 43 }
 44 void dij(int s,int g)
 45 {
 46     memset(vis,0, sizeof(vis));
 47     memset(c,0, sizeof(c));
 48     for(int i=0;i<=n;i++){
 49         d[i][0]=inf;
 50         d[i][1]=inf;
 51     }
 52     int k,ok;
 53     d[s][0]=0,c[s][0]=1;
 54
 55     for(int ii=0;ii<2*n;ii++)
 56     {
 57         int ans=inf;
 58         for(int i=1;i<=n;i++){
 59             if(!vis[i][0]&&d[i][0]<ans){//取最近的点
 60                 k=i;
 61                 ok=0;
 62                 ans=d[i][0];
 63             }
 64             else if(!vis[i][1]&&d[i][1]<ans){
 65                 k=i;
 66                 ok=1;
 67                 ans=d[i][1];
 68             }
 69         }
 70         if(ans==inf) break;
 71         vis[k][ok]=1;
 72         for(int j=h[k];j!=-1;j=e[j].nx){
 73             int v=e[j].v,w=e[j].w;
 74             if(d[v][0]>ans+w){//更新最短路
 75                 d[v][1]=d[v][0];
 76                 c[v][1]=c[v][0];
 77                 d[v][0]=ans+w;
 78                 c[v][0]=c[k][ok];
 79             }
 80             else if(d[v][0]==ans+w){//更新最短路条数
 81                 c[v][0]+=c[k][ok];
 82             }
 83             else if(d[v][1]>ans+w)//更新次短路
 84                 d[v][1]=ans+w,c[v][1]=c[k][ok];
 85             else if(d[v][1]==ans+w)//次短路条数
 86                 c[v][1]+=c[k][ok];
 87         }
 88     }
 89     if(d[g][1]==d[g][0]+1)
 90         c[g][0]+=c[g][1];
 91
 92     pi(c[g][0]);
 93
 94 }
 95 int main()
 96 {
 97     ci(t);
 98     while(t--)
 99     {
100         ci(n),ci(m);
101         e.clear();
102         cnt=0;
103         memset(h,-1, sizeof(h));
104         for(int i=0;i<m;i++){
105             int x,y,z;
106             ci(x),ci(y),ci(z);
107             add(x,y,z);
108         }
109         int s,g;
110         ci(s),ci(g);
111         dij(s,g);
112     }
113     return 0;
114
115 }
时间: 2024-08-09 10:34:26

POJ 3463 最(次)短路条数的相关文章

poj 3463 Sightseeing(次短路+条数统计)

/* 对dij的再一次理解 每个点依旧永久标记 只不过这里多搞一维 0 1 表示最短路还是次短路 然后更新次数相当于原来的两倍 更新的时候搞一下就好了 */ #include<iostream> #include<cstdio> #include<cstring> #include<queue> #include<vector> #define maxn 1010 using namespace std; int T,n,m,num,head[m

poj 3463 Sightseeing(最短路+次短路)

http://poj.org/problem?id=3463 大致题意:给出一个有向图,从起点到终点求出最短路和次短路的条数之和. 解法: 用到的数组:dis[i][0]:i到起点的最短路,dis[i][1]:i到起点的严格次短路 vis[i][0],vis[i][1]:同一维的vis数组,标记距离是否已确定 sum[i][0]:i到起点的最短路条数,sum[i][1]:i到起点的次短路条数 同一维dijkstra,内循环先找出最短的距离(次短路或最短路)d,然后枚举与该点相连的点: if(d

poj 3463 Sightseeing (dij 求最短路和次短路并计数)

dijkstra求最短路和次短路的求法和计算  模板 dijkstra求最短路的变形. 外循环要循环2*n-1次,因为dis[n][2]有2*n个状态,而dis[s][0]已经用过一次. 算法: 1.如果比最短路短就更新最短路和次短路. 2.如果和最短路相等,更新最短路的计数. 3.如果和次短路相等,更新次短路的方法数. 4.如果比次短路短,更新次短路. #include<cstdio> #include<iostream> #include<cstring> #inc

poj 3463 Sightseeing 最短路径数量

题意: 求有向图中最短路和比最短路大1的路径数量. 思路: 需要理解dijkstra算法中dis[n]数组的含义,设cnt[i]表示到点i的最短路径数量,cnt1[i]表示到点i比最短路大1的路径数量.在运行dijkstra算法的过程中每次获得最小dis[i]的时候可以对所有dis[v]+w(v,i)==dis[i]的v做如下更新cnt[i]+=cnt[v],cnt1[i]+=cnt1[v].而当所有值为某数的dis[i]计算完成时也就是对任意i,dis[i]为同一值且不再变化时,可以对这些满足

大数减法2——在较短的数前补充前导零,以对齐最低位

#define _CRT_SECURE_NO_WARNINGS #include<stdio.h> #include<string.h> int main() { char str1[255], str2[255]; int num1[255] = { 0 }, num2[255] = { 0 };//用于存放减数和被减数,且较短者补前导零 int dvalue[255] = { 0 }; int length1, length2, length; int i, j; int ne

关于 最短路条数 和 边不可重复最短路条数问题 /hdu3599(边不可重复最短路)

原先一直在做一道省赛题,由于题意错误理解成球最短路条数,误打误撞敲了最短路条数,又发现hdu3599(多校)求边不可重复最短路条数.下面说说俩种问题解法: 最短路条数: 求一个图一共一几条最短路径,思路:先从终点跑一边最短路,记录终点到到所有点最短距离(d[i]),然后从起点出发,dfs 按d[i]走(必是最短路径),一句话:我到终点的最短路条数=我的所有孩子到终点的最短路条数之和,这样只需一遍即可.这不知道是不是叫记忆化搜索? 边不可重复最短路径条数:(最短路+建新图之最大流) hdu3599

codeforces257 div2 D最短路条数

题意: 给一个无向图,总共有 n个点,m+k条边,给定点所连的k条边可以选择删除 问最多删除多少条可以保持该定点到其他点的最短路不变 题解: 从定点出发做单元最短路 首先如果定点到某个点的最短路小于 可删边的长度,则肯定可以删除 此外如果最短路与可删边长度相等,而且最短路条数大于1,肯定也可以删除 所以在做最短路的时候需要记录一下条数 //同时还会有重边,也要注意处理 ps...这题sxbk的把普通的spfa 都卡了..加了slf优化才过,据说dij可以轻松过..不过我没试2333 以后写spf

hdu 3191 How Many Paths Are There (次短路径数)

How Many Paths Are There Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1010    Accepted Submission(s): 332 Problem Description oooccc1 is a Software Engineer who has to ride to the work place

【PAT】Emergency(最短路条数-SPFA)

[PAT]Emergency(最短路条数-SPFA) As an emergency rescue team leader of a city, you are given a special map of your country. The map shows several scattered cities connected by some roads. Amount of rescue teams in each city and the length of each road betw